WeekKeys.db = {}
local db = WeekKeys.db
function db.add(DB,name,realm,colored,ilvl,record,keyid,keylevel,faction,sender)
    DB = DB or {}
    for k,v in pairs(DB) do
        if v.name == name and v.realm == realm then
            if record then
                v.record = record
            end
            if ilvl then
                v.ilvl = tonumber(ilvl)
            end
            if colored then
                v.colored = colored
            end
            if keyid then
                v.keyID = tonumber(keyid)
            end
            if keylevel then
                v.keyLevel = tonumber(keylevel)
            end
            if faction then
                v.faction = faction
            end
            if sender then
                v.sender = sender
            end
            return
        end
    end
    tinsert(DB,{
        ["name"] = name,
        ["realm"] = realm,
        ["colored"] = colored,
        ["record"] = tonumber(record),
        ["ilvl"] = tonumber(ilvl),
        ["keyLevel"] = tonumber(keylevel),
        ["keyID"] = tonumber(keyid),
        ["faction"] = faction,
        ["sender"] = sender,
    })
end

function db.getdata(DB)
    local data = {}
    for k,v in pairs(DB) do
        local player  = {}
        player.colored = v.colored
        player.ilvl = v.ilvl
        player.record = v.record
        if tonumber(v.keyID) == 370 or tonumber(v.keyID) == 369 then
            local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
            local mechagon, zone  = strsplit(" ", name ,2)
            if zone then
                player.keylink = "|cffffffff"..zone .. " ("..v.keyLevel..")"
            end
        elseif v.keyID and tonumber(v.keyID) then
            local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
            if name then
                player.keylink = "|cffffffff"..name .. " ("..v.keyLevel..")"
            end
        else
            player.keylink = ""
        end
        tinsert(data,player)
    end
    return data
end
--[[   planned functions
function db.remove(DB,name,realm)
    -- todo
end

function db.find(DB,name,realm)
    -- todo
end

function db.print(DB,channel)
    --todo
end
]]